'-------------------------------------------------------------------------------
'UNO_Timer3.BAS  B1 Fout 250 Hz...4 MHz
'-------------------------------------------------------------------------------
$regfile = "m328pdef.dat"                                   'ATmega328p
$crystal = 16000000                                         '16 MHz
$baud = 9600
$hwstack = 32
$swstack = 32
$framesize = 64

Dim D As Long
Dim F As Long
Dim N As Byte
Dim U As Word
Dim Um As Word
Dim Ux(50) As Word
Dim I As Word

Led1 Alias Portc.2
Led2 Alias Portb.2
S1 Alias Pinc.0
S2 Alias Pinc.1
Portc.0 = 1                                                 'Pullup
Portc.1 = 1
Config Led1 = Output
Config Led2 = Output

Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portd.3 , Rs = Portd.2
Config Lcd = 16 * 2
Cls
Cursor Off

Config Timer1 = Pwm , Prescale = 1 , Pwm = 10 , Compare A Pwm = Clear Up

Tccr1a = &B10000010                                         'Phase-correct PWM, Top=ICR1
Tccr1b = &B00010001                                         'Prescaler=1


Config Adc = Single , Prescaler = Auto , Reference = Internal_1.1
Start Adc


Do
  For I = 1 To 20
    D = 145 - I
    F = 16000000 / D
    F = F / 2
    Print F
   ' Locate 1 , 1
   ' Lcd F
   ' Lcd " Hz      "
    Icr1 = D
    Ocr1a = D / 2
    Waitms 10
    Um = 0
    For N = 1 To 64
      U = Getadc(4)
      Um = Um + U
    Next N
    Um = Um / 32
    Ux(i) = Um
    Print Um
   ' Locate 2 , 1
   ' Lcd Um
   ' Lcd " mV   "
   ' Waitms 500
  Next I
  Max(ux(1) , Um , I)
  D = 145 - I
  F = 16000000 / D
  F = F / 2
  Locate 1 , 1
  Lcd F
  Lcd " Hz      "
  Icr1 = D
  Ocr1a = D / 2
  Locate 2 , 1
  Lcd Um
  Lcd " mV   "
  If F > 57000 And F < 59000 And Um > 50 Then
    Waitms 50
    For N = 1 To 255
      U = Getadc(4)
      Um = Um + U
    Next N
    Um = Um / 127
    If Um > 50 Then Led1 = 1
    Lcd F
    Lcd " Hz      "
    Icr1 = D
    Ocr1a = D / 2
    Locate 2 , 1
    Lcd Um
    Lcd " mV   "
  Else
     Led1 = 0
  End If
  Waitms 1000
Loop