'-------------------------------------------------------------------------------
'UNO_shift.BAS  Shift Register 4094
'-------------------------------------------------------------------------------
$regfile = "m328pdef.dat"                                   'ATmega328p
$crystal = 16000000                                         '16 MHz
$baud = 9600

Dim Dat As Byte
Dim D As Byte
Dim N As Byte
Dim B As Bit


Sr Alias Portb.4                                            '4094 pin 1
Da Alias Portb.3                                            '4094 pin 2
Cl Alias Portb.2                                            '4094 pin 3
Config Portb = Output

Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portd.3 , Rs = Portd.2
Config Lcd = 16 * 2

Cls
Cursor Off
Dat = 0
Do
  Cls
  Lcd Dat
  Lcd "  "
  Print Dat
  D = Dat
  For N = 1 To 8
    B = D.7
    Da = B
    Waitms 1
    Cl = 1
    Waitms 1
    Cl = 0
    Waitms 1
    Shift D , Left
  Next N
  Sr = 1
  Waitms 1
  Sr = 0
  Waitms 1
  Dat = Dat + 1
  Waitms 500
Loop

End