'-------------------------------------------------------------------------------
'UNO_spi1.BAS  Shift in/out
'-------------------------------------------------------------------------------
$regfile = "m328pdef.dat"                                   'ATmega328p
$crystal = 16000000                                         '16 MHz
$baud = 9600

Dim D As Byte
Dim B As Bit
Dim N As Byte

S1 Alias Pinc.0
Portc.0 = 1                                                 'Pullup
S2 Alias Pinc.1
Portc.1 = 1                                                 'Pullup
Led1 Alias Portc.2
Ddrc.2 = 1
Led2 Alias Portb.2
Ddrb.2 = 1

Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portd.3 , Rs = Portd.2
Config Lcd = 16 * 2

Cls
Cursor Off
Do
  D = Rnd(255)
  Cls
  Lcd D
  Print D
  Locate 2 , 1
  For N = 0 To 7
     B = D.7
     Lcd B
     Print B;
     Led2 = B
     Waitms 300
     Led1 = 1
     Waitms 200
     Led1 = 0
     Waitms 500
     Shift D , Left
  Next N
  Led1 = 0
  Led2 = 0
  Waitms 2000
  Cls
  Print
  D = 0
  Do
  Loop Until S1 = 1
  For N = 0 To 7
     Shift D , Left
     Do
     Loop Until S1 = 0
     If S2 = 0 Then B = 1 Else B = 0
     D = D + B
     Lcd B
     Print B;
     Waitms 100
     Do
     Loop Until S1 = 1
     Waitms 100
  Next N
  Print
  Locate 2 , 1
  Lcd D
  Print D
  Waitms 2000
Loop
End
