   '-------------------------------------------------------------------------------
'UNO_RX2.BAS  B1 RF out, C2 RF in
'-------------------------------------------------------------------------------
$regfile = "m328pdef.dat"                                   'ATmega328p
$crystal = 16000000                                         '16 MHz
$baud = 9600
$hwstack = 16
$swstack = 16
$framesize = 16

Dim D As Word
Dim D0 As Word
Dim N As Byte

Ddrb.2 = 1

Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portd.3 , Rs = Portd.2
Config Lcd = 16 * 2
Cls
Cursor Off

Config Adc = Single , Prescaler = 8 , Reference = Avcc      '5 V

Config Timer1 = Pwm , Prescale = 1 , Pwm = 10 , Compare A Pwm = Clear Up
Tccr1a = &B10000010                                         'Phase-correct PWM, Top=ICR1
Tccr1b = &B00010001                                         'Prescaler=1

D = 4                                                       '2 MHz
Icr1 = D
Ocr1a = D / 2

D = 0
For N = 1 To 50
   Portc.2 = 1
   Waitus 100
   Portc.2 = 0
   D = D + Getadc(2)
Next N
D0 = D / 50

Do
  Portc.2 = 1
  Waitus 100
  Portc.2 = 0
  D = Getadc(2)
  If D < D0 Then
    D = D0 - D
    If D > 2 Then
      Print D
      'Locate 1 , 1
      'Lcd D
      'Lcd "    "
      Sound Portb.2 , 20 , 4000                             'LED2 and Piezo
    End If
  End If
Loop