'-------------------------------------------------------------------------------
'UNO_LCD3.BAS  PWM
'-------------------------------------------------------------------------------
$regfile = "m328pdef.dat"                                   'ATmega328p
$crystal = 16000000                                         '16 MHz
$baud = 9600

S1 Alias Pinc.0
S2 Alias Pinc.1

Dim A As Word
Dim B As Word

Config Adc = Single , Prescaler = 64 , Reference = Avcc     '5 V
Config Timer1 = Pwm , Prescale = 1 , Pwm = 10 , Compare A Pwm = Clear Up , Compare B Pwm = Clear Up
Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portd.3 , Rs = Portd.2
Config Lcd = 16 * 2
Waitms 50
Portc.0 = 1                                                 'Pullup
Portc.1 = 1                                                 'Pullup
Config Portb = Output


Cls
Cursor Off
Do
  Locate 1 , 1
  Lcd "PWMA="
  A = Getadc(3)
  Pwm1a = A
  Lcd A
  Lcd "    "

  If S1 = 0 Then
    If B > 0 Then B = B - 1
  End If
  If S2 = 0 Then
    If B < 1023 Then B = B + 1
  End If
  Pwm1b = B

  Locate 2 , 1
  Lcd "PWMB="
  Lcd B
  Lcd "    "
  Waitms 100
Loop