'-------------------------------------------------------------------------------
'UNO_Timer6.BAS  Frequency 0...4 MHz
'-------------------------------------------------------------------------------
$regfile = "m328pdef.dat"                                   'ATmega328p
$crystal = 16000000                                         '16 MHz
$baud = 9600
$hwstack = 16                                               '8
$swstack = 16                                               '4
$framesize = 16                                             '4


Dim Lowword As Word
Dim Highword As Word
Dim Ticks As Word
Dim Freq As Long

Config Timer0 = Timer , Prescale = 64
On Ovf0 Tim0_isr
Enable Timer0

Config Timer1 = Counter , Edge = Falling , Prescale = 1
On Ovf1 Tim1_isr
Enable Timer1

Config Timer2 = Pwm , Prescale = 1 , Compare A Pwm = Clear Up
Pwm2a = 128                                                 'B3: 31373 Hz
Enable Interrupts

Do
  Print Freq;
  Print " Hz        ";
  Print Chr(13);
  Waitms 1000
Loop

Tim0_isr:
  '1000 s
  Timer0 = 6
  Ticks = Ticks + 1
  If Ticks = 1 Then
    Timer1 = 0
    Highword = 0
  End If
  If Ticks = 1001 Then
    Lowword = Timer1
    Freq = Highword * 65536
    Freq = Freq + Lowword
    Ticks = 0
  End If
Return

Tim1_isr:
  Highword = Highword + 1
Return
End

