'-------------------------------------
'UNO_I2C6.BAS Read from EEPROM 24C512
'-------------------------------------
$regfile = "m328pdef.dat"                                   'ATmega328p
$crystal = 16000000                                         '16 MHz
$baud = 9600
$hwstack = 64
$swstack = 32
$framesize = 64


Dim N As Byte
Dim Adrs As Word
Dim H As Byte
Dim L As Byte
Dim Dat As Byte


Config Scl = Portc.5
Config Sda = Portc.4

Print "SI5351"
Adrs = 0
I2cstart
I2cwbyte 192                                                'slave address 24C512
'H = High(adrs)
'L = Low(adrs)
I2cwbyte 0                                                  'high address
'I2cwbyte L                                             'low address
I2cstop
I2cstart                                                    'repeated start
I2cwbyte 193                                                'slave address (read)

For Adrs = 0 To 255
 I2crbyte Dat , Ack                                         'read byte
 '
 Print Dat ;
 Print " ";
 H = Adrs And 15
 If H = 15 Then Print
 Waitms 100
Next Adrs
I2cstop                                                     'generate stop
End